const { dbManager } = require(`${global.projectRoot}/managers`);
const crypto = require('crypto');

module.exports.isAuthorized = (req, res, next) => {
  const token = (req.body && req.body.token) || req.headers.Authorization;
  const uid = crypto
    .createHash('md5')
    .update(token)
    .digest('hex');

  const users = dbManager.users().findById(dbManager.db.sessions[uid]);
  if (!users.length) {
    res.status(401);
    res.json({
      ok: false,
      error: 'invalid_auth'
    });
  }
  req.user = users[0];
  return next();
};
